<?php
    $self = 'manager/includes/session_db.php';
    $base_path = str_replace($self,'',str_replace('\\', '/', __FILE__));
    if(!is_file($base_path.'manager/includes/config.session.php')) {
        define('MODX_DB_SESSION_OK',false);
    } else {
        define('MODX_DB_SESSION_OK',true);
    }

    function my_session_get_db() {
        include('config.session.php');

        global $my_session_host;
        global $my_session_account_id;
        global $my_session_account_pass;
        global $my_session_database;
//        $database_server             = 'localhost';
//        $database_user               = 'root';
//        $database_password           = 'paradise';
//        $dbase                       = 'tokai_tlc_point';
        $my_session_host = $database_server;
        $my_session_account_id = $database_user;
        $my_session_account_pass = $database_password;
        $my_session_database = $dbase;

        $db = null;
        $db = new mysqli(
            $my_session_host.':3306',
            $my_session_account_id,
            $my_session_account_pass,
            $my_session_database
        );

        if($db->connect_errno){
            die('Unable to connect');
        }

        return $db;
    }


    class MySessionHandler implements SessionHandlerInterface {
        // セッション終了時に呼び出される。
        function close() {
            return true;
        }

        // セッション破棄時に呼び出される。
        function destroy($session_id) {
            $db = my_session_get_db();
            if($stmt = $db->prepare("DELETE FROM modx_tbl_session WHERE session_id = ?")){
                $stmt->bind_param("s", $session_id);
                $stmt->execute();
                $stmt->close();
                $stmt = null;
            }
            $db->close();
            $db = null;
            return true;
        }

        // セッションがメモリから削除される時に呼び出される。
        function gc($maxlifetime) {
            $db = my_session_get_db();

            if($stmt = $db->prepare("
            DELETE
            FROM modx_tbl_session
            WHERE create_date < ?")){

//                date_default_timezone_set("UTC");
                $t = time() - $maxlifetime;

                $stmt->bind_param("i", $t);
                $stmt->execute();
                $stmt->close();
                $stmt=null;
            }

            $db->close();
            $db=null;
            return true;
        }

        // セッション開始時に呼び出される。
        function open($save_path, $name) {
            return true;
        }

        // セッションデータ読み込み時に呼び出される。
        function read($session_id) {
            $session_data = '';
            $db = my_session_get_db();
            if($stmt = $db->prepare("SELECT session_data FROM modx_tbl_session WHERE session_id = ?")){
                $stmt->bind_param("s", $session_id);
                $stmt->bind_result($session_data);
                $stmt->execute();
                $stmt->fetch();
                $stmt->close();
                $stmt = null;
            }
            $db->close();
            $db = null;

            if(is_null($session_data)) {
                $session_data = '';
            }
            return $session_data;
        }

        // セッションデータ書き込み時に呼び出される。
        function write($session_id, $session_data) {
            $affected_rows = 0;
            $create_date = time();
            $db = my_session_get_db();
            if($stmt = $db->prepare("INSERT INTO modx_tbl_session (session_id, session_data, CREATE_DATE) VALUES(?, ?, ?) ON DUPLICATE KEY UPDATE session_data = ?, create_date = ?")){
                $stmt->bind_param("ssisi", $session_id, $session_data, $create_date, $session_data, $create_date);
                $stmt->execute();
                $affected_rows = $stmt->affected_rows;
                $stmt->close();
                $stmt = null;
            }
            $db->close();
            $db = null;
//            return $affected_rows ? true : false;
            return true;
        }

    }
